﻿//
// Porting and modifications made by Rayzzor Studios, 2011
//

/***************************************************************************** 
* Free42 -- an HP-42S calculator simulator 
* Copyright (C) 2004-2010 Thomas Okken 
* 
* This program is free software; you can redistribute it and/or modify 
* it under the terms of the GNU General Public License, version 2, 
* as published by the Free Software Foundation. 
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public License 
* along with this program; if not, see http://www.gnu.org/licenses/. 
*****************************************************************************/

namespace WP7_42s
{
    public partial class App
    {
        public enum off_methods
        {
            exit,
            display_off
        }


        /**********/
        /* Errors */
        /**********/
        public enum ERR
        {
            NONE = 0,
            ALPHA_DATA_IS_INVALID = 1,
            INSUFFICIENT_MEMORY = 2,
            NOT_YET_IMPLEMENTED = 3,
            OUT_OF_RANGE = 4,
            DIVIDE_BY_0 = 5,
            INVALID_TYPE = 6,
            INVALID_DATA = 7,
            DIMENSION_ERROR = 8,
            SIZE_ERROR = 9,
            INTERNAL_ERROR = 10,
            NONEXISTENT = 11,
            RESTRICTED_OPERATION = 12,
            YES = 13,
            NO = 14,
            STOP = 15,
            LABEL_NOT_FOUND = 16,
            NO_REAL_VARIABLES = 17,
            NO_COMPLEX_VARIABLES = 18,
            NO_MATRIX_VARIABLES = 19,
            NO_MENU_VARIABLES = 20,
            STAT_MATH_ERROR = 21,
            INVALID_FORECAST_MODEL = 22,
            SOLVE_INTEG_RTN_LOST = 23,
            SINGULAR_MATRIX = 24,
            SOLVE_SOLVE = 25,
            INTEG_INTEG = 26,
            RUN = 27,
            INTERRUPTED = 28,
            PRINTING_IS_DISABLED = 29,
            INTERRUPTIBLE = 30,
            NO_VARIABLES = 31
        }



        /*************/
        /* Key codes */
        /*************/
        public enum KEY
        {
            KEY_SIGMA = 1,
            KEY_INV = 2,
            KEY_SQRT = 3,
            KEY_LOG = 4,
            KEY_LN = 5,
            KEY_XEQ = 6,
            KEY_STO = 7,
            KEY_RCL = 8,
            KEY_RDN = 9,
            KEY_SIN = 10,
            KEY_COS = 11,
            KEY_TAN = 12,
            KEY_ENTER = 13,
            KEY_SWAP = 14,
            KEY_CHS = 15,
            KEY_E = 16,
            KEY_BSP = 17,
            KEY_UP = 18,
            KEY_7 = 19,
            KEY_8 = 20,
            KEY_9 = 21,
            KEY_DIV = 22,
            KEY_DOWN = 23,
            KEY_4 = 24,
            KEY_5 = 25,
            KEY_6 = 26,
            KEY_MUL = 27,
            KEY_SHIFT = 28,
            KEY_1 = 29,
            KEY_2 = 30,
            KEY_3 = 31,
            KEY_SUB = 32,
            KEY_EXIT = 33,
            KEY_0 = 34,
            KEY_DOT = 35,
            KEY_RUN = 36,
            KEY_ADD = 37
        }



        /*********/
        /* Menus */
        /*********/
        public enum MENU
        {
            NONE = -1,
            SHORTCUT = -2,
            ALPHA1 = 0,
            ALPHA2 = 1,
            ALPHA_ABCDE1 = 2,
            ALPHA_ABCDE2 = 3,
            ALPHA_FGHI = 4,
            ALPHA_JKLM = 5,
            ALPHA_NOPQ1 = 6,
            ALPHA_NOPQ2 = 7,
            ALPHA_RSTUV1 = 8,
            ALPHA_RSTUV2 = 9,
            ALPHA_WXYZ = 10,
            ALPHA_PAREN = 11,
            ALPHA_ARROW = 12,
            ALPHA_COMP = 13,
            ALPHA_MATH = 14,
            ALPHA_PUNC1 = 15,
            ALPHA_PUNC2 = 16,
            ALPHA_MISC1 = 17,
            ALPHA_MISC2 = 18,
            ST = 19,
            IND_ST = 20,
            IND = 21,
            MODES1 = 22,
            MODES2 = 23,
            DISP = 24,
            CLEAR1 = 25,
            CLEAR2 = 26,
            CONVERT1 = 27,
            CONVERT2 = 28,
            FLAGS = 29,
            PROB = 30,
            CUSTOM1 = 31,
            CUSTOM2 = 32,
            CUSTOM3 = 33,
            PGM_FCN1 = 34,
            PGM_FCN2 = 35,
            PGM_FCN3 = 36,
            PGM_FCN4 = 37,
            PGM_XCOMP0 = 38,
            PGM_XCOMPY = 39,
            PRINT1 = 40,
            PRINT2 = 41,
            PRINT3 = 42,
            TOP_FCN = 43,
            CATALOG = 44,
            BLANK = 45,
            PROGRAMMABLE = 46,
            VARMENU = 47,
            STAT1 = 48,
            STAT2 = 49,
            STAT_CFIT = 50,
            STAT_MODL = 51,
            MATRIX1 = 52,
            MATRIX2 = 53,
            MATRIX3 = 54,
            MATRIX_SIMQ = 55,
            MATRIX_EDIT1 = 56,
            MATRIX_EDIT2 = 57,
            BASE = 58,
            BASE_A_THRU_F = 59,
            BASE_LOGIC = 60,
            SOLVE = 61,
            INTEG = 62,
            INTEG_PARAMS = 63
        }



        /************/
        /* Commands */
        /************/
        public enum CMD
        {
            /* These are indices into the cmdlist array,
             * declared below (except the negative ones!)
             */
            NONE = -1,
            CANCELLED = -2,
            LINGER1 = -3,
            LINGER2 = -4,
            CLX = 0,
            ENTER = 1,
            SWAP = 2,
            RDN = 3,
            CHS = 4,
            DIV = 5,
            MUL = 6,
            SUB = 7,
            ADD = 8,
            LASTX = 9,
            SILENT_OFF = 10,
            SILENT_ON = 11,
            SIN = 12,
            COS = 13,
            TAN = 14,
            ASIN = 15,
            ACOS = 16,
            ATAN = 17,
            LOG = 18,
            TEN_POW_X = 19,
            LN = 20,
            E_POW_X = 21,
            SQRT = 22,
            SQUARE = 23,
            INV = 24,
            Y_POW_X = 25,
            PERCENT = 26,
            PI = 27,
            COMPLEX = 28,
            STO = 29,
            STO_DIV = 30,
            STO_MUL = 31,
            STO_SUB = 32,
            STO_ADD = 33,
            RCL = 34,
            RCL_DIV = 35,
            RCL_MUL = 36,
            RCL_SUB = 37,
            RCL_ADD = 38,
            FIX = 39,
            SCI = 40,
            ENG = 41,
            ALL = 42,
            NULL = 43,
            ASTO = 44,
            ARCL = 45,
            CLA = 46,
            DEG = 47,
            RAD = 48,
            GRAD = 49,
            RECT = 50,
            POLAR = 51,
            SIZE = 52,
            QUIET = 53,
            CPXRES = 54,
            REALRES = 55,
            KEYASN = 56,
            LCLBL = 57,
            RDXDOT = 58,
            RDXCOMMA = 59,
            CLSIGMA = 60,
            CLP = 61,
            CLV = 62,
            CLST = 63,
            CLRG = 64,
            DEL = 65,
            CLKEYS = 66,
            CLLCD = 67,
            CLMENU = 68,
            CLALLa = 69,
            TO_DEG = 70,
            TO_RAD = 71,
            TO_HR = 72,
            TO_HMS = 73,
            TO_REC = 74,
            TO_POL = 75,
            IP = 76,
            FP = 77,
            RND = 78,
            ABS = 79,
            SIGN = 80,
            MOD = 81,
            SF = 82,
            CF = 83,
            FS_T = 84,
            FC_T = 85,
            FSC_T = 86,
            FCC_T = 87,
            COMB = 88,
            PERM = 89,
            FACT = 90,
            GAMMA = 91,
            RAN = 92,
            SEED = 93,
            LBL = 94,
            RTN = 95,
            INPUT = 96,
            VIEW = 97,
            AVIEW = 98,
            XEQ = 99,
            PROMPT = 100,
            PSE = 101,
            ISG = 102,
            DSE = 103,
            AIP = 104,
            XTOA = 105,
            AGRAPH = 106,
            PIXEL = 107,
            BEEP = 108,
            TONE = 109,
            MVAR = 110,
            VARMENU = 111,
            GETKEY = 112,
            MENU = 113,
            KEYG = 114,
            KEYX = 115,
            X_EQ_0 = 116,
            X_NE_0 = 117,
            X_LT_0 = 118,
            X_GT_0 = 119,
            X_LE_0 = 120,
            X_GE_0 = 121,
            X_EQ_Y = 122,
            X_NE_Y = 123,
            X_LT_Y = 124,
            X_GT_Y = 125,
            X_LE_Y = 126,
            X_GE_Y = 127,
            PRSIGMA = 128,
            PRP = 129,
            PRV = 130,
            PRSTK = 131,
            PRA = 132,
            PRX = 133,
            PRUSR = 134,
            LIST = 135,
            ADV = 136,
            PRLCD = 137,
            DELAY = 138,
            PON = 139,
            POFF = 140,
            MAN = 141,
            NORM = 142,
            TRACE = 143,
            SIGMAADD = 144,
            SIGMASUB = 145,
            GTO = 146,
            END = 147,
            NUMBER = 148,
            STRING = 149,
            RUN = 150,
            SST = 151,
            GTODOT = 152,
            GTODOTDOT = 153,
            STOP = 154,
            NEWMAT = 155,
            RUP = 156,
            REAL_T = 157,
            CPX_T = 158,
            STR_T = 159,
            MAT_T = 160,
            DIM_T = 161,
            ASSIGNa = 162,
            ASSIGNb = 163,
            ASGN01 = 164,
            ASGN02 = 165,
            ASGN03 = 166,
            ASGN04 = 167,
            ASGN05 = 168,
            ASGN06 = 169,
            ASGN07 = 170,
            ASGN08 = 171,
            ASGN09 = 172,
            ASGN10 = 173,
            ASGN11 = 174,
            ASGN12 = 175,
            ASGN13 = 176,
            ASGN14 = 177,
            ASGN15 = 178,
            ASGN16 = 179,
            ASGN17 = 180,
            ASGN18 = 181,
            ON = 182,
            OFF = 183,
            KEY1G = 184,
            KEY2G = 185,
            KEY3G = 186,
            KEY4G = 187,
            KEY5G = 188,
            KEY6G = 189,
            KEY7G = 190,
            KEY8G = 191,
            KEY9G = 192,
            KEY1X = 193,
            KEY2X = 194,
            KEY3X = 195,
            KEY4X = 196,
            KEY5X = 197,
            KEY6X = 198,
            KEY7X = 199,
            KEY8X = 200,
            KEY9X = 201,
            VMEXEC = 202,
            VMSTO = 203,
            SIGMAREG = 204,
            SIGMAREG_T = 205,
            CLD = 206,
            ACOSH = 207,
            ALENG = 208,
            ALLSIGMA = 209,
            AND = 210,
            AOFF = 211,
            AON = 212,
            AROT = 213,
            ASHF = 214,
            ASINH = 215,
            ATANH = 216,
            ATOX = 217,
            BASEADD = 218,
            BASESUB = 219,
            BASEMUL = 220,
            BASEDIV = 221,
            BASECHS = 222,
            BEST = 223,
            BINM = 224,
            BIT_T = 225,
            BST = 226,
            CORR = 227,
            COSH = 228,
            CROSS = 229,
            CUSTOM = 230,
            DECM = 231,
            DELR = 232,
            DET = 233,
            DIM = 234,
            DOT = 235,
            EDIT = 236,
            EDITN = 237,
            EXITALL = 238,
            EXPF = 239,
            E_POW_X_1 = 240,
            FCSTX = 241,
            FCSTY = 242,
            FNRM = 243,
            GETM = 244,
            GROW = 245,
            HEXM = 246,
            HMSADD = 247,
            HMSSUB = 248,
            I_ADD = 249,
            I_SUB = 250,
            INDEX = 251,
            INSR = 252,
            INTEG = 253,
            INVRT = 254,
            J_ADD = 255,
            J_SUB = 256,
            LINF = 257,
            LINSIGMA = 258,
            LN_1_X = 259,
            LOGF = 260,
            MEAN = 261,
            NOT = 262,
            OCTM = 263,
            OLD = 264,
            OR = 265,
            PGMSLV = 266,
            PGMINT = 267,
            POSA = 268,
            PUTM = 269,
            PWRF = 270,
            RCLEL = 271,
            RCLIJ = 272,
            RNRM = 273,
            ROTXY = 274,
            RSUM = 275,
            SWAP_R = 276,
            SDEV = 277,
            SINH = 278,
            SLOPE = 279,
            SOLVE = 280,
            STOEL = 281,
            STOIJ = 282,
            SUM = 283,
            TANH = 284,
            TRANS = 285,
            UVEC = 286,
            WMEAN = 287,
            WRAP = 288,
            X_SWAP = 289,
            XOR = 290,
            YINT = 291,
            TO_DEC = 292,
            TO_OCT = 293,
            LEFT = 294,
            UP = 295,
            DOWN = 296,
            RIGHT = 297,
            PERCENT_CH = 298,
            SIMQ = 299,
            MATA = 300,
            MATB = 301,
            MATX = 302,
            GOTOROW = 303,
            GOTOCOLUMN = 304,
            A_THRU_F = 305,
            CLALLb = 306,
            PGMSLVi = 307,
            PGMINTi = 308,
            VMSTO2 = 309,
            VMSOLVE = 310,
            MAX = 311,
            MIN = 312,
            FIND = 313,
            XROM = 314,
            /* Underhill's COPAN extensions */
            OPENF = 315,
            CLOSEF = 316,
            READP = 317,
            WRITEP = 318,
            GETXY = 319,
            PUTXY = 320,
            CLRP = 321,
            CLRD = 322,
            APPD = 323,
            GETN = 324,
            PUTN = 325,
            GETZ = 326,
            PUTZ = 327,
            DELP = 328,
            /* Byron Foster's Bigstack extension */
            DROP = 329,
            /* iPhone hardware support */
            ACCEL = 330,
            LOCAT = 331,
            HEADING = 332,
            /* HP-41 Time Module & CX Time */
            ADATE = 333,
            ALMCAT = 334,
            ALMNOW = 335,
            ATIME = 336,
            ATIME24 = 337,
            CLK12 = 338,
            CLK24 = 339,
            CLKT = 340,
            CLKTD = 341,
            CLOCK = 342,
            CORRECT = 343,
            DATE = 344,
            DATE_PLUS = 345,
            DDAYS = 346,
            DMY = 347,
            DOW = 348,
            MDY = 349,
            RCLAF = 350,
            RCLSW = 351,
            RUNSW = 352,
            SETAF = 353,
            SETDATE = 354,
            SETIME = 355,
            SETSW = 356,
            STOPSW = 357,
            SW = 358,
            T_PLUS_X = 359,
            TIME = 360,
            XYZALM = 361,
            CLALMA = 362,
            CLALMX = 363,
            CLRALMS = 364,
            RCLALM = 365,
            SWPT = 366,
            SENTINEL = 367
        }


        /***********************/
        /* Variable data types */
        /***********************/
        public enum TYPE
        {
            NULL = 0,
            REAL = 1,
            COMPLEX = 2,
            REALMATRIX = 3,
            COMPLEXMATRIX = 4,
            STRING = 5
        }
    }
}