﻿// Copyright Rayzzor Studios 2011 
// 
// This file is part of 42S.
// 
// 42S is free software: you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
// 
// 42S is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
// GNU General Public License for more details. 
// 
// You should have received a copy of the GNU General Public License 
// along with 42S. If not, see <http://www.gnu.org/licenses/>. 

using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace WP7_42s
{
    public partial class Display : UserControl
    {
        private const bool useLayoutRounding = false;

        private const int numRows = 16;
		private const int numColumns = 132;
        private const double gap = 0;
		
		private const double sizeX = 2;
		private const double sizeY = 3;

        private static bool load_complete = false;

        private WriteableBitmap DispBM;


        public Display()
		{
			InitializeComponent();

            _UpDown.Opacity = 0;
            _Shift.Opacity = 0;
            _Print.Opacity = 0;
            _Run.Opacity = 0;
            _GRAD.Opacity = 0;
        }


        public void SetPixel(int x, int y, double opacity)
        {
            int alpha = opacity == 1 ? 0xff << 24 : 0;

            for (int xp = 0; xp < sizeX; xp++)
                for (int yp = 0; yp < sizeY; yp++)
                    DispBM.Pixels[(x * (int)sizeX + xp) + (y * (int)sizeY + yp) * numColumns * (int)sizeX] = 0 | alpha;

            DispBM.Invalidate();
        }
        
		private void SetupPixels()
		{
            DispBM = new WriteableBitmap(numColumns * (int)sizeX, numRows * (int)sizeY);
            dispImg.Source = DispBM;
		}

        private void DisplayLines_Loaded(object sender, RoutedEventArgs e)
        {
            if (!load_complete)
            {
                SetupPixels();

                load_complete = true;
            }
        }

        public void Enable()
        {
            VisualStateManager.GoToState(this, "DisplayOn", true);
        }

        public void Disable()
        {
            VisualStateManager.GoToState(this, "DisplayOff", true);
        }
    }
}