﻿// Copyright Rayzzor Studios 2011 
// 
// This file is part of 42S.
// 
// 42S is free software: you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
// 
// 42S is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
// GNU General Public License for more details. 
// 
// You should have received a copy of the GNU General Public License 
// along with 42S. If not, see <http://www.gnu.org/licenses/>. 

using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Microsoft.Phone.Tasks;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;

using System.IO;
using System.IO.IsolatedStorage;
using System.Runtime.Serialization;

using System.Text;
using System.Collections;
using System.Windows.Threading;
using System.Threading;
using System.ComponentModel;
using System.Windows.Controls.Primitives;
using Microsoft.Phone.Marketplace;
using Microsoft.Xna.Framework.GamerServices;


namespace WP7_42s
{
    public partial class MainPage : PhoneApplicationPage
    {
        private static TimeSpan NAG_INTERVAL = new TimeSpan(0, 2, 0);
        private static int NAG_COUNTDOWN = 10;

        public static bool load_complete = false;

        private static DispatcherTimer AudioCheck;
        private static bool AudioPlaying;
        private static DispatcherTimer prgm_cont;
        private static DispatcherTimer AudioComplete;
        private static DispatcherTimer TrialNag = new DispatcherTimer();
        private DispatcherTimer tcountdown = new DispatcherTimer();
        private int countdown;
        private bool firstDisp = true;

        private static ApplicationBarIconButton abClearPrint;
        private static ApplicationBarIconButton abInfo;
        private static ApplicationBarIconButton abSync;
        private static ApplicationBarIconButton abDisconnect;

        private BackgroundWorker backroundWorker;


        public MainPage()
        {
            InitializeComponent();

            InfoPopup.IsOpen = false;

            LicenseInformation licInfo = new LicenseInformation();
            TrialPopup.IsOpen = App.trialMode;

            if (App.showSplash)
                ShowLoadingSplash();

            // Reinstate MouseLeftButtonDownEvent to keyboard buttons
            bSum.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bInv.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bSqrt.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bLog.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bLn.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bXeq.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);

            bSto.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bRcl.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bPi.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bSin.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bCos.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bTan.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);

            bEnter.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bExch.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bSign.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bE.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bClr.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);

            bBst.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            b7.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            b8.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            b9.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bDiv.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);

            bSst.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            b4.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            b5.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            b6.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bMul.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);

            bShift.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            b1.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            b2.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            b3.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bSub.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);

            bExit.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bOn.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            b0.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bDot.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bRS.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);
            bAdd.AddHandler(UIElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(Button_MouseLeftButtonDown), true);


            abClearPrint = new ApplicationBarIconButton(new Uri("/icons/appbar.cancel.rest.png", UriKind.Relative));
            abClearPrint.Text = "clear";
            abClearPrint.Click += new EventHandler(abClearPrint_Click);

            abInfo = new ApplicationBarIconButton(new Uri("/icons/appbar.info.png", UriKind.Relative));
            abInfo.Text = "info";
            abInfo.Click += new EventHandler(abInfo_Click);

// Transfer page removal
//            abSync = new ApplicationBarIconButton(new Uri("/icons/appbar.sync.rest.png", UriKind.Relative));
//            abSync.Text = "connect";
//            abSync.Click += new EventHandler(abSync_Click);

//            abDisconnect = new ApplicationBarIconButton(new Uri("/icons/appbar.cancel.rest.png", UriKind.Relative));
//            abDisconnect.Text = "disconnect";
//            abDisconnect.Click += new EventHandler(abDisconnect_Click);

//            tbStatus.Text = "";

            piPrint.Height = 535;       // TODO: is hardcoding the best thing to do?  Different resolution devices will need to adjust


            SoundEffect.MasterVolume = 1.0f;

            AudioPlaying = false;
            App.tones = new List<int>();

            AudioCheck = new DispatcherTimer();
            AudioCheck.Interval = new TimeSpan(0, 0, 0, 0, 33);
            AudioCheck.Tick += new EventHandler(AudioCheck_Tick);

            prgm_cont = new DispatcherTimer();
            prgm_cont.Interval = new TimeSpan(0, 0, 0, 0, 50);
            prgm_cont.Tick += new EventHandler(prgm_cont_Tick);

            CloseSplash.Completed += new EventHandler(CloseSplash_Completed);
            CloseInfo.Completed += new EventHandler(CloseInfo_Completed);

            OpenTry.Completed += new EventHandler(OpenTry_Completed);
            tcountdown.Tick += new EventHandler(countdown_Tick);
            CloseTry.Completed += new EventHandler(CloseTry_Completed);
            CloseTryUp.Completed += new EventHandler(CloseTry_Completed);
            TrialNag.Tick += new EventHandler(TrialNag_Tick);
        }

		// =====================================================

        void TrialNag_Tick(object sender, EventArgs e)
        {
            TrialNag.Stop();
            ShowTry();
        }
        
        private void ShowTry()
        {
            TrialPopup.IsOpen = true;
            ApplicationBar.IsVisible = false;
            bContinue.IsEnabled = false;

            OpenTry.Begin();
        }

        void OpenTry_Completed(object sender, EventArgs e)
        {
            continueEnCountdown();
        }

        private void continueEnCountdown()
        {
            countdown = NAG_COUNTDOWN;
            bContinue.Content = string.Format("Continue ({0})", countdown);

            tcountdown.Interval = new TimeSpan(0, 0, 1);
            tcountdown.Start();
        }

        void countdown_Tick(object sender, EventArgs e)
        {
            countdown -= 1;

            if (countdown == 0)
            {
                tcountdown.Stop();
                bContinue.Content = "Continue";
                bContinue.IsEnabled = true;
            }
            else
                bContinue.Content = string.Format("Continue ({0})", countdown);
        }

        private void bBuy_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            doBuy();
        }


        private void bInfoBuy_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            doBuy();
        }

        private void doBuy()
        {
            MarketplaceDetailTask detailTask = new MarketplaceDetailTask();

            detailTask.ContentIdentifier = null;

            detailTask.Show();
        }

        // -----------------------------------------------------

        private void bContinue_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            if (firstDisp)
            {
                firstDisp = false;
                CloseTryUp.Begin();
            }
            else
                CloseTry.Begin();
        }

        void CloseTry_Completed(object sender, EventArgs e)
        {
            TrialPopup.IsOpen = false;
            setAppBar();

            TrialNag.Interval = NAG_INTERVAL;
            
            TrialNag.Start();
        }

        // =====================================================

        // Simple splash screen that just runs a storyboard (for quick loading apps
        private void ShowSplash()
        {
            SplashPopup.IsOpen = true;

            // For simple splash, just run a storyboard
            CloseSplash.Begin();
        }

        // -----------------------------------------------------

        // Both methods use event handler to close popup
        void CloseSplash_Completed(object sender, EventArgs e)
        {
            SplashPopup.IsOpen = false;
        }

        // -----------------------------------------------------

        // Splash to display while working on a background thread.  Can implement progress bar or other effects while loading.
        // This meathod is not used in this version as load time is fast
        private void ShowLoadingSplash()
        {
            SplashPopup.IsOpen = true;

            // For loading action during splashscreen with progress bar, use backgroundworker thread
            backroundWorker = new BackgroundWorker();
            backroundWorker.DoWork += new DoWorkEventHandler(backroundWorker_DoWork);
            backroundWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(backroundWorker_RunWorkerCompleted);
            backroundWorker.RunWorkerAsync();
        }

        void backroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            Dispatcher.BeginInvoke(() =>
            {
                CloseSplash.Begin();
            } );
        }

        void backroundWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            // Do any initial load work needed here... Add progress bar if needed.

            // Force splash on screen for at least a minimum amount of time if load is too fast
            Thread.Sleep(new TimeSpan(0, 0, 0, 0, 500));
        }

        // =====================================================


        //
        // Calculator Page
        //

        private void ContentGrid_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            // TODO: Make sure HW keyboard input can be accepted.
            // Need a way to get FULL focus on page without user interaction (ie boarder outline around page)
            // To use keyboard in emulator, select page, then press PageUp to enable or PageDown to disable (or pause/break to toggle)
            this.IsTabStop = true;
            this.Focus();

            if (!load_complete)
            {
                App.Disp = this.Disp;
                App.Main = this;

                App.core_init(App.FREE42_VERSION);

                if (App.core_powercycle() != 0)
                    App.running = 1;

                vsBeep.Value = App.prefBeepVol;
                vsKeyClick.Value = App.prefKeyClickVol;
                tsHighlight.IsChecked = App.prefKeyHighlightEn;

                App.redisplay();

                load_complete = true;
            }

            AudioCheck.Start();
            prgm_cont.Start();
        }


        private void prgm_cont_Tick(object sender, EventArgs e)
        {
            if (!App.calc_off)
            {
                int dummy1 = 0;
                int dummy2 = 0;
                App.running = App.core_keydown(0, ref dummy1, ref dummy2);
            }
        }

        private void AudioCheck_Tick(object sender, EventArgs e)
        {
            FrameworkDispatcher.Update();

            if (App.tones.Count > 0 && !AudioPlaying)
                PlayTone();
        }

        private void PlayTone()
        {
            double volume;

            if (App.tones.Count == 0)
                return;

            if ((App.tones[0] <= 10 && App.prefBeepVol <= 0) || (App.tones[0] == 11 && App.prefKeyClickVol <= 0))
            {
                App.tones.RemoveAt(0);
                AudioPlaying = false;

                if (App.tones.Count == 0)
                    App.prgm_block = false;

                return;
            }

            string s = string.Empty;
            volume = App.prefBeepVol;

            switch (App.tones[0])
            {
                case 0: s = "Assets/tone0.wav"; break;
                case 1: s = "Assets/tone1.wav"; break;
                case 2: s = "Assets/tone2.wav"; break;
                case 3: s = "Assets/tone3.wav"; break;
                case 4: s = "Assets/tone4.wav"; break;
                case 5: s = "Assets/tone5.wav"; break;
                case 6: s = "Assets/tone6.wav"; break;
                case 7: s = "Assets/tone7.wav"; break;
                case 8: s = "Assets/tone8.wav"; break;
                case 9: s = "Assets/tone9.wav"; break;

                case 10: s = "Assets/squeak.wav"; break;

                case 11:
                    s = "Assets/click.wav";                      // NOTE: short sounds (< 100 mS ?) don't appear to play reliably on emulator
                    volume = App.prefKeyClickVol;
                    break;

                default:
                    App.tones.RemoveAt(0);
                    AudioPlaying = false;

                    if (App.tones.Count == 0)
                        App.prgm_block = false;
                    
                    return;
            }

            if (s != string.Empty)
            {
                App.tones.RemoveAt(0);

                AudioPlaying = true;
                App.prgm_block = true;

                PlaySound(s, volume);
            }
        }

        private void PlaySound(string soundFile, double volume)
        {
            using (Stream s = TitleContainer.OpenStream(soundFile))
            {
                AudioComplete = new DispatcherTimer();
                AudioComplete.Tick += new EventHandler(AudioComplete_Tick);

                SoundEffect se = SoundEffect.FromStream(s);
                FrameworkDispatcher.Update();

                se.Play((float)volume, 0.0f, 0.0f);

                AudioComplete.Interval = se.Duration;
                AudioComplete.Start();
            }
        }

        void AudioComplete_Tick(object sender, EventArgs e)
        {
            AudioComplete.Stop();
            AudioPlaying = false;

            if (App.tones.Count == 0)
                App.prgm_block = false;
        }


        public void show_on()
        {
            VisualStateManager.GoToState(this, "ShowOn", true);
            set_keys_power_state(false);
        }

        public void hide_on()
        {
            VisualStateManager.GoToState(this, "Normal", true);
            set_keys_power_state(true);
        }



        public void set_keys_power_state(bool s)
        {
                bSum.IsEnabled = s;
                bInv.IsEnabled = s;
                bSqrt.IsEnabled = s;
                bLog.IsEnabled = s;
                bLn.IsEnabled = s;
                bXeq.IsEnabled = s;

                bSto.IsEnabled = s;
                bRcl.IsEnabled = s;
                bPi.IsEnabled = s;
                bSin.IsEnabled = s;
                bCos.IsEnabled = s;
                bTan.IsEnabled = s;

                bEnter.IsEnabled = s;
                bExch.IsEnabled = s;
                bSign.IsEnabled = s;
                bE.IsEnabled = s;
                bClr.IsEnabled = s;

                bBst.IsEnabled = s;
                b7.IsEnabled = s;
                b8.IsEnabled = s;
                b9.IsEnabled = s;
                bDiv.IsEnabled = s;

                bSst.IsEnabled = s;
                b4.IsEnabled = s;
                b5.IsEnabled = s;
                b6.IsEnabled = s;
                bMul.IsEnabled = s;

                bShift.IsEnabled = s;
                b1.IsEnabled = s;
                b2.IsEnabled = s;
                b3.IsEnabled = s;
                bSub.IsEnabled = s;

//                bExit.IsEnabled = s;
//                bOn.IsEnabled = s;
                b0.IsEnabled = s;
                bDot.IsEnabled = s;
                bRS.IsEnabled = s;
                bAdd.IsEnabled = s;
        }

        public int find_key(string name, bool shift)
        {
            switch (name)
            {
                case "bSum": return App.KEY_SIGMA;
                case "bInv": return App.KEY_INV;
                case "bSqrt": return App.KEY_SQRT;
                case "bLog": return App.KEY_LOG;
                case "bLn": return App.KEY_LN;
                case "bXeq": return App.KEY_XEQ;

                case "bSto": return App.KEY_STO;
                case "bRcl": return App.KEY_RCL;
                case "bPi": return App.KEY_RDN;
                case "bSin": return App.KEY_SIN;
                case "bCos": return App.KEY_COS;
                case "bTan": return App.KEY_TAN;

                case "bEnter": return App.KEY_ENTER;
                case "bExch": return App.KEY_SWAP;
                case "bSign": return App.KEY_CHS;
                case "bE": return App.KEY_E;
                case "bClr": return App.KEY_BSP;

                case "bBst": return App.KEY_UP;
                case "b7": return App.KEY_7;
                case "b8": return App.KEY_8;
                case "b9": return App.KEY_9;
                case "bDiv": return App.KEY_DIV;

                case "bSst": return App.KEY_DOWN;
                case "b4": return App.KEY_4;
                case "b5": return App.KEY_5;
                case "b6": return App.KEY_6;
                case "bMul": return App.KEY_MUL;

                case "bShift": return App.KEY_SHIFT;
                case "b1": return App.KEY_1;
                case "b2": return App.KEY_2;
                case "b3": return App.KEY_3;
                case "bSub": return App.KEY_SUB;

                case "bExit": return App.KEY_EXIT;
                case "bOn": return App.KEY_EXIT;
                case "b0": return App.KEY_0;
                case "bDot": return App.KEY_DOT;
                case "bRS": return App.KEY_RUN;
                case "bAdd": return App.KEY_ADD;

                default: return 0;
            }
        }

        private void Button_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            App.ckey = find_key(((Button)sender).Name, App.ann_shift != 0);

            if (App.ckey != 0)
            {
                App.shell_keydown();
                App.mouse_key = true;
            }
        }

        private void Button_Release(object sender, RoutedEventArgs e)
        {
            this.Focus();       // Required to remove focus from button and restore to page for propper keydown and keyup operation

            if (App.ckey != 0 && App.mouse_key)
                App.shell_keyup();
        }


        // Prevent pivot from sliding while working with keyboard (swipe display to slide page)
        private void Keys_ManipulationStarted(object sender, System.Windows.Input.ManipulationStartedEventArgs e)
        {
            e.Complete();
        }



        //
        // Pivot setup
        //

        private void Pivot_LoadingPivotItem(object sender, Microsoft.Phone.Controls.PivotItemEventArgs e)
        {
            setAppBar();
        }

        private void setAppBar()
        {
            if (TrialPopup.IsOpen || InfoPopup.IsOpen)
                ApplicationBar.IsVisible = false;
            else if (((PivotItem)(pivotCtrl.SelectedItem)).Header == piPrint.Header)
            {
                ApplicationBar.Buttons.Clear();
                ApplicationBar.Buttons.Add(abClearPrint);

                ApplicationBar.IsVisible = true;

                if (App.scrollPrint)
                {
                    // Ensure child layout is complete and scroll to bottom using a very large offset
                    printStack.UpdateLayout();
                    printScroll.ScrollToVerticalOffset(1000000);
                    App.scrollPrint = false;
                }
            }
            // Transfer page removal
/*            else if (((PivotItem)(pivotCtrl.SelectedItem)).Header == piFileXfr.Header)
            {
                abSync.IsEnabled = true;
                abDisconnect.IsEnabled = false;

                ApplicationBar.Buttons.Clear();
                ApplicationBar.Buttons.Add(abSync);
                ApplicationBar.Buttons.Add(abDisconnect);

                ApplicationBar.IsVisible = true;
            }
*/
            else if (((PivotItem)(pivotCtrl.SelectedItem)).Header == piSettings.Header)
            {
                ApplicationBar.Buttons.Clear();
                ApplicationBar.Buttons.Add(abInfo);

                ApplicationBar.IsVisible = true;
            }
            else
                ApplicationBar.IsVisible = false;
        }

        private void PhoneApplicationPage_BackKeyPress(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (InfoPopup.IsOpen && !TrialPopup.IsOpen)
            {
                CloseInfo.Begin();

                e.Cancel = true;
            }
        }

        void CloseInfo_Completed(object sender, EventArgs e)
        {
            InfoPopup.IsOpen = false;
            setAppBar();
        }


        //
        // Options page
        //

        private void vsBeep_ValueChanged(object sender, System.EventArgs e)
        {
            App.prefBeepVol = ((VolSliderControl)sender).Value;
        }

        private void vsKeyClick_ValueChanged(object sender, System.EventArgs e)
        {
            App.prefKeyClickVol = ((VolSliderControl)sender).Value;
        }

        private void tsHighlight_Changed(object sender, RoutedEventArgs e)
        {
            App.prefKeyHighlightEn = tsHighlight.IsChecked == true;
            App.update_annunciators();
        }

        private void abInfo_Click(object sender, System.EventArgs e)
        {
            ApplicationBar.IsVisible = false;
            InfoPopup.IsOpen = true;

            Button buyNow = (Button)FindVisualChildByName<DependencyObject>(InfoPopup.Child, "bInfoBuy");

            if (buyNow != null)
                buyNow.Visibility = App.trialMode ? System.Windows.Visibility.Visible : System.Windows.Visibility.Collapsed;

            OpenInfo.Begin();
        }

        public static T FindVisualChildByName<T>(DependencyObject parent, string name) where T : DependencyObject
        {
            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(parent); i++)
            {
                var child = VisualTreeHelper.GetChild(parent, i);
                string controlName = child.GetValue(Control.NameProperty) as string;
                if (controlName == name)
                {
                    return child as T;
                }
                else
                {
                    T result = FindVisualChildByName<T>(child, name);
                    if (result != null)
                        return result;
                }
            }
            return null;
        }

        //
        // Print page
        //

        private void abClearPrint_Click(object sender, System.EventArgs e)
        {
            printStack.Children.Clear();
            App.imgNum = 0;

            IsolatedStorageFile isf = IsolatedStorageFile.GetUserStoreForApplication();
            string[] fnames = isf.GetFileNames();
            foreach (string s in fnames)
                if (s != App.STATE_FILE)
                    isf.DeleteFile(s);
        }



        //
        // Connect page
        //

        void abSync_Click(object sender, EventArgs e)
        {
            abSync.IsEnabled = false;
            abDisconnect.IsEnabled = true;
// Transfer page removal
//            tbAddress.IsEnabled = false;
//            hlWebSite.IsEnabled = false;
            
            pivotCtrl.IsEnabled = false;
        }

        void abDisconnect_Click(object sender, EventArgs e)
        {
            abSync.IsEnabled = true;
            abDisconnect.IsEnabled = false;
// Transfer page removal
//            tbAddress.IsEnabled = true;
//            hlWebSite.IsEnabled = true;

            pivotCtrl.IsEnabled = true;
        }

// Transfer page removal
/*        private void HyperlinkButton_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            var wbt = new WebBrowserTask();
            wbt.URL = "http://" + (string)hlWebSite.Content + "/";
            wbt.Show();
        }
*/

        
        #region HW keyboard support
/*
        private void PhoneApplicationPage_KeyDown(object sender, KeyEventArgs e)
        {
            Key key = e.Key;
            char keychar = (char)e.PlatformKeyCode;

            App.just_pressed_shift = false;

            if (key == Key.Ctrl)
            {
                App.ctrl_down = true;
                return;
            }
            else if (key == Key.Alt)
            {
                App.alt_down = true;
                return;
            }
            else if (key == Key.Shift)
            {
                App.shift_down = true;
                App.just_pressed_shift = true;
                return;
            }

            // TODO: Eliminate specials (tab/escape/etc)?  See orig source that should be here

            if (App.ckey == 0 || !App.mouse_key)
            {
                int i;
                bool printable = keychar >= 32 && keychar <= 126;

                if (App.ckey != 0)
                {
                    App.shell_keyup();
                    App.active_keycode = 0;
                }

                if (printable && App.core_alpha_menu())
                {
                    if (App.shift_down)
                        if (keychar >= 'a' && keychar <= 'z')
                            keychar = (char)(keychar + 'A' - 'a');
                        else if (keychar >= 'A' && keychar <= 'Z')
                            keychar = (char)(keychar + 'a' - 'A');

                    App.ckey = 1024 + keychar;
                    App.macro = null;

                    App.shell_keydown();
                    App.mouse_key = false;
                    App.active_keycode = (int)key;

                    return;
                }
                else if (App.core_hex_menu() && ((keychar >= 'a' && keychar <= 'f') || (keychar >= 'A' && keychar <= 'F')))
                {
                    if (keychar >= 'a' && keychar <= 'f')
                        App.ckey = keychar - 'a' + 1;
                    else
                        App.ckey = keychar - 'A' + 1;

                    App.macro = null;

                    App.shell_keydown();
                    App.mouse_key = false;
                    App.active_keycode = (int)key;

                    return;
                }


                bool exact = false;
                bool cshift_down = App.ann_shift != 0;

                byte[] key_macro = App.keymap_lookup(keychar, App.ctrl_down, App.alt_down, App.shift_down, cshift_down, ref exact);

                if (key_macro == null || !exact)
                {
                    for (i = 0; i < App.keymap.Length; i++)
                    {
                        App.keymap_entry entry = App.keymap[i];

                        if (App.ctrl_down == entry.ctrl
                                && App.alt_down == entry.alt
                                && App.shift_down == entry.shift
                                && keychar == entry.keycode)
                        {
                            if (cshift_down == entry.cshift)
                            {
                                key_macro = entry.macro;
                                break;
                            }
                            else
                            {
                                if (key_macro == null)
                                    key_macro = entry.macro;
                            }
                        }
                    }
                }

                if (key_macro != null)
                {
                    // A keymap entry is a sequence of zero or more calculator
                    // keystrokes (1..37) and/or macros (38..255). We expand
                    // macros here before invoking shell_keydown().
                    // If the keymap entry is one key, or two keys with the
                    // first being 'shift', we highlight the key in question
                    // by setting ckey; otherwise, we set ckey to -10, which
                    // means no skin key will be highlighted.
                    App.ckey = -10;

                    if (key_macro[0] != 0)
                        if (key_macro[1] == 0)
                            App.ckey = key_macro[0];
                        else if (key_macro[2] == 0 && key_macro[0] == 28)
                            App.ckey = key_macro[1];

                    bool needs_expansion = false;

                    for (int j = 0; key_macro[j] != 0; j++)
                        if (key_macro[j] > 37)
                        {
                            needs_expansion = true;
                            break;
                        }

                    if (needs_expansion)
                    {
                        byte[] macrobuf = new byte[0];
                        int p = 0;

                        for (int j = 0; key_macro[j] != 0 && p < 1023; j++)
                        {
                            byte c = key_macro[j];

                            if (c <= 37)
                            {
                                Array.Resize(ref macrobuf, macrobuf.Length + 1);
                                macrobuf[macrobuf.Length - 1] = c;
                            }
                            else
                            {
                                byte[] m = App.find_macro(c);

                                if (m != null)
                                    foreach (byte b in m)
                                    {
                                        Array.Resize(ref macrobuf, macrobuf.Length + 1);
                                        macrobuf[macrobuf.Length - 1] = b;
                                    }
                            }
                        }

                        Array.Resize(ref macrobuf, macrobuf.Length + 1);
                        macrobuf[macrobuf.Length - 1] = 0;
                        App.macro = macrobuf;
                    }
                    else
                        App.macro = key_macro;

                    App.shell_keydown();
                    App.mouse_key = false;
                    App.active_keycode = (int)key;
                }
            }
        }

        private void PhoneApplicationPage_KeyUp(object sender, KeyEventArgs e)
        {
            Key key = e.Key;
            char keychar = (char)e.PlatformKeyCode;

            if (key == Key.Ctrl)
            {
                App.ctrl_down = false;
                return;
            }
            else if (key == Key.Alt)
            {
                App.alt_down = false;
                return;
            }
            else if (key == Key.Shift)
            {
                App.shift_down = false;

                if (App.ckey == 0 && App.just_pressed_shift)
                {
                    App.ckey = 28;
                    App.macro = null;

                    App.shell_keydown();
                    App.shell_keyup();
                }

                return;
            }

            if (App.ckey != 0 && !App.mouse_key && (int)key == App.active_keycode)
            {
                App.shell_keyup();
                App.active_keycode = 0;
            }
        }
*/
        #endregion
    }
}
